import usePolling from '../hook/Polling';

export default function useGamesApi(gamesReducer, config) {
    const [games, dispatchGames] = gamesReducer;

    const usePollingGamesList = () => {
        const onSuccess = (gamesList) => {
            dispatchGames({ type: 'next', gamesList });
        }

        const isPollingGamesList = usePolling('/api/games', onSuccess, config.intervalMode(30));
        if (games.isPollingGamesList !== isPollingGamesList) {
            dispatchGames({ type: 'next', isPollingGamesList });
        }

        return games;
    }

    const usePushNewGame = () => {
        const onSuccess = (game) => {
            dispatchGames({ type: 'next', game });
        }
    }

    return {
        pollGamesList: usePollingGamesList,
        pushNewGame: usePushNewGame
    }
}